//Compare this to the code in 3_hard_to_compose
//To run, first type 
//npm install
//on the command line from under the 
//11_promise_all directory. Then run 
//node sample.js

var fs = require('fs-promise');

var isPrime = function(number) {
  if(number === 1) return false;

  for(var i = 2; i < number; i++) {
    if(number % i === 0)
      return false;
  }
  return true;
}

var countPrimes = function(number) {
  var count = 0;
  for(var i = 1; i <= number; i++) {
    if(isPrime(i))
      count++;
  }           

  return count;
}

var countPrimesAsync = function(number) {
  return new Promise(function(resolve, reject) {
    var invokeLater = function() { resolve(countPrimes(number)); };
    setTimeout(invokeLater, 1);
  });
}

var splitLines = function(lines) { return lines.toString().split('\n'); };

var numberAndPrimesCount = function(number) {
  return countPrimesAsync(number)
    .then(function(count) { return number + ":" + count; });
}

var processLines = function(lines) {
  return Promise.all(lines.map(numberAndPrimesCount));
};

var displayResults = function(results) {
  results.forEach(function(result) { console.log(result); });
}

fs.readFile('numbers.txt')
  .then(splitLines)
  .then(processLines)
  .then(displayResults)
  .catch(function(err) { console.log(err); });