var fs = require('fs');

var isPrime = function(number) {
  if(number === 1) return false;

  for(var i = 2; i < number; i++) {
    if(number % i === 0)
      return false;
  }
  return true;
}

var countPrimesAsync = function(number, callback) {
  var countPrimes = function(number) {
    var count = 0;
    for(var i = 1; i <= number; i++) {
      if(isPrime(i))
        count++;
    }           

    return count;
  }

  setTimeout(function() { callback(countPrimes(number)); },
    1);
}

var handleResponse = function(err, lines) {
  if(err)
    console.log("error reading file");
  else {
    var numbers = lines.toString().split("\n");
    
    var results = [];
    
    var processCount = function(number, count) {
      results.push(number + ":" + count);
      
      if(results.length === numbers.length)
        results.forEach(function(result) { console.log(result); });
    }

    for(var i = 0; i < numbers.length; i++) {
      countPrimesAsync(+numbers[i], processCount.bind(null, numbers[i]));
    }
  }    
}                              

fs.readFile('numbers.txt', handleResponse);